"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _Ionicons = _interopRequireDefault(require("react-native-vector-icons/Ionicons"));

var _styles = require("./styles");

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint-disable no-shadow */
const defaultProps = {
  style: {},
  textStyle: {},
  iconColor: 'black'
};
let selectItem = [];
let defaultValue = [];

const CheckboxTreeComponent = /*#__PURE__*/_react.default.forwardRef((props, ref) => {
  const {
    data,
    keyField,
    textField,
    childField,
    style,
    textStyle,
    iconColor = 'black',
    iconSize = 26,
    openIcon,
    closeIcon,
    checkIcon,
    unCheckIcon,
    autoSelectParents = true,
    autoSelectChilds = true,
    renderItem
  } = props;
  const [listData, setListData] = (0, _react.useState)(_lodash.default.cloneDeep(data));
  const [key, setKey] = (0, _react.useState)(Math.random());
  (0, _react.useImperativeHandle)(ref, () => {
    return {
      clear,
      setSelectedItem,
      updateListData
    };
  });

  const clear = () => {
    onClear(listData);
  };

  const updateListData = data => {
    const tmpData = _lodash.default.cloneDeep(data);

    setListData(tmpData);
    onDefault(tmpData, false);
  };

  const onClear = items => {
    items.map(item => {
      item.tick = false;
      item.show = false;

      if (item[childField]) {
        onClear(item[childField]);
      }
    });
    reload();
  };

  const setSelectedItem = data => {
    defaultValue = data;
    onDefault(listData, false);
  };

  const onDefault = function (items) {
    let tick = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    items.map(item => {
      const check = _lodash.default.filter(defaultValue, e => e === item[keyField]).length > 0;

      if (tick) {
        item.tick = true;
      } else {
        if (check) {
          item.tick = true;
        }
      }

      if (item[childField]) {
        onDefault(item[childField], autoSelectChilds && item.tick);
      }
    });
    reload();
  };

  const parent = item => {
    if (item && item[childField]) {
      const check = item[childField].filter(child => !child.tick);

      if (check.length === 0) {
        item.tick = true;
      } else {
        item.tick = false;
      }

      parent(item.parent);
      reload();
    }
  };

  const onTick = item => {
    item.tick = true;

    if (autoSelectParents) {
      parent(item.parent);
    }

    if (item[childField] && autoSelectChilds) {
      item[childField].map(child => onTick(child));
    }

    reload();
  };

  const onUnTick = item => {
    item.tick = false;

    if (autoSelectParents) {
      parent(item.parent);
    }

    if (item[childField] && autoSelectChilds) {
      item[childField].map(child => onUnTick(child));
    }

    reload();
  };

  const showChild = item => {
    item.show = !item.show;
    reload();
  };

  const onSelectItem = () => {
    const selectedItem = _lodash.default.cloneDeep(selectItem).map(e => {
      delete e.parent;
      delete e.childs;
      delete e.show;
      delete e.tick;
      return e;
    });

    props.onSelect(selectedItem);
  };

  const reload = _lodash.default.throttle(() => {
    setKey(Math.random());
    selectItem = [];
    selectItemTick(listData);
    onSelectItem();
  }, 500);

  const selectItemTick = data => {
    data.map(item => {
      if (item.tick) {
        selectItem.push(item);
      }

      if (item[childField]) {
        selectItemTick(item[childField]);
      }
    });
  };

  const _renderIcon = status => {
    if (status) {
      if (checkIcon) {
        return checkIcon;
      } else {
        return /*#__PURE__*/_react.default.createElement(_Ionicons.default, {
          name: "ios-checkbox-outline",
          size: iconSize,
          color: iconColor
        });
      }
    } else {
      if (unCheckIcon) {
        return unCheckIcon;
      } else {
        return /*#__PURE__*/_react.default.createElement(_Ionicons.default, {
          name: "stop-outline",
          size: iconSize,
          color: iconColor
        });
      }
    }
  };

  const renderList = (item, childs, index) => {
    if (!item.show) {
      item.show = false;
    }

    if (!item.tick) {
      item.tick = false;
    }

    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: [_styles.styles.item, {
        marginLeft: iconSize
      }],
      key: index
    }, renderItem ? renderItem({
      item: item,
      isSelect: item.tick,
      isOpen: item.show,
      onOpen: () => {
        showChild(item);
      },
      onClose: () => {
        showChild(item);
      },
      onSelect: () => {
        !item.tick ? onTick(item) : onUnTick(item);
      }
    }) : /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: _styles.styles.rowItem
    }, childs && childs.length > 0 ? /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        showChild(item);
      }
    }, item.show ? openIcon ? openIcon : /*#__PURE__*/_react.default.createElement(_Ionicons.default, {
      name: "ios-remove",
      size: iconSize,
      color: iconColor
    }) : closeIcon ? closeIcon : /*#__PURE__*/_react.default.createElement(_Ionicons.default, {
      name: "add-outline",
      size: iconSize,
      color: iconColor
    })) : /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: {
        width: iconSize
      }
    }, `  `), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      style: _styles.styles.flex1,
      onPress: () => {
        if (!item.tick) {
          onTick(item);
        } else {
          onUnTick(item);
        }
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: _styles.styles.center
    }, _renderIcon(item.tick), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: [_styles.styles.name, textStyle],
      numberOfLines: 3
    }, item[textField])))), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: [!item.show && _styles.styles.height0]
    }, childs && childs.map((data, index) => {
      if (!data.parent) {
        data.parent = item;
      }

      return renderList(data, data[childField], index);
    })));
  };

  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [_styles.styles.container, style]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.FlatList, {
    data: listData,
    renderItem: _ref => {
      let {
        item,
        index
      } = _ref;
      return renderList(item, item[childField], index);
    },
    keyExtractor: (_item, index) => index.toString(),
    showsVerticalScrollIndicator: false,
    extraData: key
  }));
});

CheckboxTreeComponent.defaultProps = defaultProps;
var _default = CheckboxTreeComponent;
exports.default = _default;
//# sourceMappingURL=index.js.map